'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _Node2 = require('../Node');

var _Node3 = _interopRequireDefault(_Node2);

// TODO: create JSXBoundaryElement?

var JSXOpeningElement = (function (_Node) {
    _inherits(JSXOpeningElement, _Node);

    function JSXOpeningElement(childNodes) {
        _classCallCheck(this, JSXOpeningElement);

        _get(Object.getPrototypeOf(JSXOpeningElement.prototype), 'constructor', this).call(this, 'JSXOpeningElement', childNodes);
    }

    _createClass(JSXOpeningElement, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var attributes = [];
            var selfClosing = false;

            children.passToken('Punctuator', '<');
            children.skipNonCode();
            var name = children.passOneOfNode(['JSXIdentifier', 'JSXMemberExpression', 'JSXNamespacedName']);
            children.skipNonCode();

            while (true) {
                if (children.isNode('JSXAttribute')) {
                    children.skipNonCode();
                    attributes.push(children.passNode('JSXAttribute'));
                    children.skipNonCode();
                } else if (children.isNode('JSXSpreadAttribute')) {
                    children.skipNonCode();
                    attributes.push(children.passNode('JSXSpreadAttribute'));
                    children.skipNonCode();
                } else {
                    break;
                }
            }

            if (children.isToken('Punctuator', '/')) {
                children.skipNonCode();
                children.passToken('Punctuator', '/');
                selfClosing = true;
                children.skipNonCode();
            }

            children.passToken('Punctuator', '>');
            children.assertEnd();

            this._name = name;
            this._attributes = attributes;
            this._selfClosing = selfClosing;
        }
    }, {
        key: 'name',
        get: function get() {
            return this._name;
        }
    }, {
        key: 'attributes',
        get: function get() {
            return this._attributes;
        }
    }, {
        key: 'selfClosing',
        get: function get() {
            return this._selfClosing;
        }
    }]);

    return JSXOpeningElement;
})(_Node3['default']);

exports['default'] = JSXOpeningElement;
module.exports = exports['default'];