'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _Node2 = require('../Node');

var _Node3 = _interopRequireDefault(_Node2);

var TemplateElement = (function (_Node) {
    _inherits(TemplateElement, _Node);

    function TemplateElement(childNodes) {
        _classCallCheck(this, TemplateElement);

        _get(Object.getPrototypeOf(TemplateElement.prototype), 'constructor', this).call(this, 'TemplateElement', childNodes);
    }

    _createClass(TemplateElement, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var templateToken = children.passToken('Template');

            var tail = false;
            var value = {
                cooked: templateToken.value,
                raw: templateToken.sourceCode
            };

            children.assertEnd();

            this._tail = tail;
            this._value = value;
        }
    }, {
        key: 'tail',
        get: function get() {
            return this._tail;
        },
        set: function set(bool) {
            this._tail = bool;
        }
    }, {
        key: 'value',
        get: function get() {
            return this._value;
        }
    }]);

    return TemplateElement;
})(_Node3['default']);

exports['default'] = TemplateElement;
module.exports = exports['default'];